## palo-2.13.tar.gz

=== ipl/Makefile ===
CFILES=\
	byteio.c      elf64.c	    ipl.c	  offset.c      gzip.c \
	diskpart.c    ext2.c	    lib.c	  pdc_bootio.c  vsprintf.c \
	elf32.c	      fileio.c	    load.c	  pdc_cons.c	pdc_misc.c

OFILES=$(CFILES:.c=.o)

INCLUDES=bootloader.h common.h load.h

# cc-cross-prefix
# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
# Return first prefix where a prefix$(CC) is found in PATH.
# If no $(CC) found in PATH with listed prefixes return nothing
cc-cross-prefix =  \
	$(word 1, $(foreach c,$(1),                                   \
		$(shell set -e;                                       \
		if (which $(strip $(c))gcc) > /dev/null 2>&1 ; then   \
			echo $(c);                                    \
		fi)))

# cross compilation
CC_ARCHES = hppa hppa1.1
CC_SUFFIXES = linux linux-gnu unknown-linux-gnu
CROSS_COMPILE := $(call cc-cross-prefix, \
	$(foreach a,$(CC_ARCHES), \
	$(foreach s,$(CC_SUFFIXES),$(a)-$(s)-)))

CC	= ${CROSS_COMPILE}gcc
AR	= ar
LD	= ${CROSS_COMPILE}ld

ifneq ("$(wildcard /etc/debian_version)","")
BLDINFO := $(shell echo http://www.parisc-linux.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
else
BLDINFO := $(shell echo http://www.parisc-linux.org - `LC_TIME=C date`)
endif

# Source sharing with palo
VPATH=../lib:.

AFLAGS	= -I../lib
CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks -fno-builtin
LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'

all:	iplelf

iplelf:	crt0.o ipl.a
	echo "const char bld_info[] = \"$(BLDINFO)\";" > build.c
	$(CC) $(CFLAGS) -c -o build.o build.c
	-rm -f build.c
	$(LD) $(LDFLAGS) -o iplelf crt0.o ipl.a build.o `$(CC) -print-libgcc-file-name`

ipl.a:	$(OFILES)
	$(AR) rv ipl.a $?

clean:
	rm -f iplelf *.o *.a

distclean: clean


.S.o:
	$(CC) -D__ASSEMBLY__ $(AFLAGS) -traditional -c -o $*.o $<

byteio.o \
ext2.o \
fileio.o \
lib.o \
offset.o \
pdc_bootio.o \
pdc_cons.o \
vsprintf.o :		bootloader.h

ipl.o :		bootloader.h load.h

diskpart.o :		common.h

elf32.o \
elf64.o \
load.o \
som.o :		common.h load.h

=== debian/changelog ===
palo (2.13) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Reduce ext4 debug output
  * rpm: Fix building rpm package on Fedora 30 via "make rpm"
  * Update Standards-Version to 4.4.1, no changes required

  [ Jeroen Roovers ]
  * ipl: Ensure no GCC builtins replace string functions

 -- Helge Deller <deller@gmx.de>  Wed, 20 May 2020 19:35:50 +0000

palo (2.12) unstable; urgency=medium

  [ James Bottomley ]
  * ext2: fix ext4 group cache

  [ Helge Deller ]
  * Update Standards-Version to 4.4.0, no changes required
  * Various code cleanups, pdc.h sync, add rpm build target
  * Update README file

 -- Helge Deller <deller@gmx.de>  Tue, 10 Sep 2019 12:01:26 +0200

palo (2.11) unstable; urgency=medium

  [ James Bottomley ]
  * Fix loading of compressed kernels by reducing .bss usage

 -- Helge Deller <deller@gmx.de>  Wed, 31 Jul 2019 09:39:23 +0200

palo (2.10) unstable; urgency=medium

  [ James Bottomley ]
  * Update palo documentation
  * palo: place iplboot inside disk label if it's big enough
  * palo: add support for formatting as ext4
  * iplboot: add ext4 support

 -- Helge Deller <deller@gmx.de>  Sun, 21 Jul 2019 19:06:09 +0200

palo (2.01) unstable; urgency=medium

  [ Helge Deller ]
  * Recommend instead of suggest e2fsprogs in debian control file.
    (Closes: #887258)
  * Wire up help2man to create better man page (suggested by
    Andreas Henriksson <andreas@fatal.se>)
  * fix sprintf out-of-bounds check in iplboot code

  [ James Bottomley ]
  * fix IPL overlap with ext2/ext3 resize_inode

 -- Helge Deller <deller@gmx.de>  Wed, 17 Jan 2018 15:15:40 +0100

palo (2.00) unstable; urgency=medium

  [ Helge Deller ]
  * Default to console=ttyS0 on all machines (incl. rp34x0).
  * Fix layout when printing partition table with discs > 100GB.
  * Fix up boot messages with regard to newline behaviour.
  * Include palo version identifier in binary ipl code.

  [ Rolf Eike Beer ]
  * Allow to override ar.

 -- Helge Deller <deller@gmx.de>  Mon, 01 Jan 2018 21:07:58 +0100

palo (1.99) unstable; urgency=medium

  * Increase loadable kernel size to 100MB.
  * Improve debug output and error handling.
  * Add hidden "d" command to toggle debug mode in interactive mode.

 -- Helge Deller <deller@gmx.de>  Fri, 18 Aug 2017 11:50:44 +0200

palo (1.98) unstable; urgency=medium

  * Default to console=ttyS1 on rp34x0 machines.

 -- Helge Deller <deller@gmx.de>  Tue, 30 May 2017 13:12:20 -0700

palo (1.97) unstable; urgency=medium

  * Enable support for cross-building of iplboot: (Closes: #851792)
    [ Helge Deller ]
    - Add gcc-hppa-linux-gnu and libc6-dev-hppa-cross to
      Build-Depends on architectures other than hppa.
    - Modify ipl/Makefile to support cross-compiling.
    [ John Paul Adrian Glaubitz ]
    - Build palo on amd64, i386, hppa and x32 only.
    - Move building of iplboot from dh_auto_clean to dh_auto_build.

 -- Helge Deller <deller@gmx.de>  Thu, 26 Jan 2017 14:48:37 +0100

palo (1.96) unstable; urgency=medium

  * Make the build reproducible. (Closes: #778437)
  * Unbreak loading Linux kernels bigger than 16 MB.
  * Enable support for gcc-6.

 -- Helge Deller <deller@gmx.de>  Sun, 08 Oct 2016 22:40:31 +0100

palo (1.95) unstable; urgency=medium

  * Re-add build dependency on lynx, generate README from
    README.html again. Fixes FTBFS on hppa.
  * Update pre-built iplboot bootloader code.

 -- Helge Deller <deller@gmx.de>  Sun, 06 Apr 2014 13:12:44 -0600

palo (1.94) unstable; urgency=medium

  [ Helge Deller ]
  * Fix build on non-Linux kernels.
  * Provide possibility to configure used MAKE tool via environment
    variable. Since palo requires GNU make, this gives an option to
    set MAKE=gnumake on HP-UX.
  * Disable getopt library on HP-UX.
  * Do not hardcode gcc compiler in Makefile, e.g. on HP-UX
    aCC can be used.
  * Use printf("0x%08x") instead of printf("%p"), which is not
    supported on HP-UX.
  * Provide endianess byteswapping functions for HP-UX.
  * Provide pre-built README file to avoid dependency on lynx.

  [ John Paul Adrian Glaubitz ]
  * Remove boiler plate comment and fix wording in debian/rules.

 -- Helge Deller <deller@gmx.de>  Sat, 05 Apr 2014 11:31:51 +0200

palo (1.93) unstable; urgency=medium

  [Helge Deller]
  * Reintroduce package to Debian. (Closes: #742068)

  [John Paul Adrian Glaubitz]
  * Clean up debian/changelog.
  * Clean up debian/README.Debian.
  * Add debian/README.source to explain the version
    history of the PALO sources in Debian.
  * Bump debhelper level to 9.
  * Use dh to streamline debian/rules.
  * Remove usr/bin and usr/sbin from debian/dirs, they are empty.
  * Update debian/copyright to copyright format 1.0.

 -- Helge Deller <deller@gmx.de>  Tue, 18 Mar 2014 13:47:42 -0600

palo (1.92) unstable; urgency=low

  * Increase possible command line length from 127 to 1024 bytes.
  * Each kernel parameter can hold up to 200 chars (79 before).
  * Various smaller bugfixes.

 -- Helge Deller <deller@gmx.de>  Wed, 09 Oct 2013 17:47:54 +0200

palo (1.91) unstable; urgency=low

  * Add spec-file for RPM.
  * Remove debug infos.
  * Add overflow checks.

 -- Helge Deller <deller@gmx.de>  Sat, 06 Jul 2013 22:08:05 +0200

palo (1.90) unstable; urgency=low

  * New maintainer.
  * Add support for gzip-compressed kernel images.
  * Add boot menu option "x" to reset/reboot the machine.
  * Lots of other small bug fixes.

 -- Helge Deller <deller@gmx.de>  Tue, 02 Jul 2013 21:22:36 +0200

palo (1.16) UNRELEASED; urgency=low

  [Matthew Wilcox]
  * Increase allowed size from 20MB to 800MB when creating lifimage files
    for booting over the network.

  [ Kyle McMartin ]
  * Fix FTBFS on ia64: Useful macros were undefined in userspace.

 -- Kyle McMartin <kyle@debian.org>  Mon, 26 Nov 2007 17:09:38 -0500

palo (1.15) unstable; urgency=low

  [ Kyle McMartin ]
  * Make the message when using the -U option on an unformatted
    volume slightly more helpful.

  [ Jeff Bailey ]


=== debian/control ===
Source: palo
Section: admin
Priority: optional
Maintainer: Helge Deller <deller@gmx.de>
Uploaders:
Build-Depends: debhelper (>= 9), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa], help2man
Standards-Version: 4.4.1
Homepage: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
Vcs-Browser: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/deller/palo.git

Package: palo
Architecture: amd64 i386 hppa x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: e2fsprogs
Description: Linux boot loader for HP PA-RISC
 PALO is the boot loader for HP PA-RISC machines. This package contains
 both the actual boot loader called iplboot as well as a boot media
 management tool after which bears the name PALO. While iplboot
 can be used on PA-RISC machines only, the PALO media management tool
 runs on any architecture and is used to create boot media for
 HP PA-RISC machines.
